/** LXT's Present */

package control;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.StringTokenizer;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import sun.misc.BASE64Decoder;
import sun.misc.BASE64Encoder;

import model.Function;
import model.MyObject;

/**
 * Servlet implementation class Index
 */
public class Index extends HttpServlet {
	private static final long serialVersionUID = 1L;
       
    /**
     * @see HttpServlet#HttpServlet()
     */
    public Index() {
        super();
        // TODO Auto-generated constructor stub
    }

	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		request.setCharacterEncoding("UTF-8");
	    response.setCharacterEncoding("UTF-8");
	    response.setContentType("text/html; charset=UTF-8");
	    
	    /* Thiet lap thu muc de lay noi dung */
	    String folder = request.getParameter("folder");
	    if (folder == null) folder = "";
	    
	    /* Giai ma Base64 thu muc */
	    folder = new String(new BASE64Decoder().decodeBuffer(folder), "UTF-8");
	   
	    /* Duong dan that */
	    String path = getServletContext().getRealPath("/" + folder);
	    
	    /* Duong dan co dinh icon file */
	    String IMG_PATH = "xtPrivate/icon/";
	    
	    /* Lay noi dung: tat ca tep tin va thu muc */	    
	    File file = new File(path);
	    if (file.exists()){
		    File[] fileList = file.listFiles();
		    ArrayList<MyObject> contents = new ArrayList<MyObject>();
		    MyObject mo;
		    
			for (int i = 0; i < fileList.length; i++) {
				if (fileList[i].isFile() && !Function.isHiddenObject(fileList[i].getName())){
					mo = new MyObject(IMG_PATH + Function.getIcon(fileList[i].getName().substring(fileList[i].getName().lastIndexOf(".") + 1, fileList[i].getName().length())), folder + "/" + fileList[i].getName(), fileList[i].getName(), Function.sizeFormat(fileList[i].length()), Function.dateFormat(fileList[i].lastModified()));
					contents.add(mo);
				} else {
					if (!Function.isHiddenObject(fileList[i].getName())){
						
						/* Lay kich thuoc folder */
						long total = Function.getFolderSize(path + "/" + fileList[i].getName());
						String sTotal = "0";
						if (total != 0) sTotal = Function.sizeFormat(total);
						
						/* Ma hoa Base64 thu muc */
						String presentFolder = folder + "/" + fileList[i].getName();
						presentFolder = new BASE64Encoder().encode(presentFolder.getBytes("UTF-8"));
						
						mo = new MyObject(IMG_PATH + "folder.gif", "/?folder=" + presentFolder, fileList[i].getName(), sTotal, Function.dateFormat(fileList[i].lastModified()));
						contents.add(mo);
					}
				}	
			}
			
			/* Xu ly lien ket cho Header */		
			StringTokenizer tokens = new StringTokenizer(folder, "/");
			String[] items = new String[tokens.countTokens()];
			int i = 0;
			while(tokens.hasMoreTokens()){
				items[i] = tokens.nextToken();
				i++;
			}
			String link = "";
			String comp = "";
			for(int k = 0; k < items.length; k++){
				comp = "";
				for(int t = 0; t <= k; t++){
					comp += "/" + items[t];
				}
				link += "<a href='?folder=" + new BASE64Encoder().encode(comp.getBytes("UTF-8")) + "'>" + items[k] + "</a>/";
			}
			
			/* Ajax See More */
			HttpSession session = request.getSession();
			session.setAttribute("list", contents);
			
			/* Chuyen trang */	
			request.setAttribute("contents", contents);
			request.setAttribute("presentFolder", folder);
			request.setAttribute("link", link);
			RequestDispatcher rd = request.getRequestDispatcher("_xtshow.jsp");
	        rd.forward(request, response);
	    } else response.sendRedirect("");
	}

	/**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		doGet(request, response);
	}

}
