/** LXT's Present */

package model;

import java.io.File;
import java.text.DecimalFormat;
import java.text.SimpleDateFormat;

public class Function {
	
	public static String getIcon(String extension){
		String icon = null;
		String[] FILE_TYPES = {"mp3", "java", "txt", "jpg", "png", "zip", "rar", "js", "pdf", "ppt", "xls", "doc", "exe", "gif"};
		String[] FILE_ICONS = {"audio.gif", "java.gif", "text_plain.gif", "image.gif", "image.gif", "zip.gif", "rar.gif", "js.gif", "pdf.gif", "ppt.gif", "xls.gif", "text.gif", "bat.gif", "image.gif"};
		
		for (int i = 0; i < FILE_TYPES.length; i++) {
			if (FILE_TYPES[i].equalsIgnoreCase(extension)){
				icon = FILE_ICONS[i];
				break;
			}
		}
		
		if (icon == null){
			icon = "unknown.gif";
		}
		
		return icon;
	}
	
	public static boolean isHiddenObject(String obj){
		boolean result = false;
		String[] object = {"WEB-INF", "META-INF", "index.jsp", "_xtshow.jsp", "xtPrivate", "favicon.ico"};
		for (int i = 0; i < object.length; i++) {
			if (object[i].equalsIgnoreCase(obj)){
				result = true;
				break;
			}
		}
		return result;
	}
	
	public static String dateFormat(long date){
	    SimpleDateFormat formatter = new SimpleDateFormat("dd/MM/yy HH:mm");
	    return formatter.format(date);
	}
	
	public static String sizeFormat(long b){
		String result = "";
		
		if(b <= 0) result = "0";
	    String[] units = new String[] { "Byte", "KB", "MB", "GB", "TB" };
	    int digitGroups = (int) (Math.log10(b)/Math.log10(1024));
	    result = new DecimalFormat("#,##0.##").format(b/Math.pow(1024, digitGroups)) + " " + units[digitGroups];
	    return result;
	}
	
	public static long getFolderSize(String path){
		long result = 0;
		File file = new File(path);
		File[] fileList = file.listFiles();
		for (int i = 0; i < fileList.length; i++) {
			if (fileList[i].isFile()){
				result += fileList[i].length();
			}
			else {
				result += getFolderSize(fileList[i].getAbsolutePath());
			}
		}
		return result;
	}
	
	public static void main(String[] args) {
		String str = "D:/ba";
		System.out.println(sizeFormat(getFolderSize(str)));
	}
}
